;<!HTML View Formatting><html><body bgcolor="#d8e8ff"><pre><font face="courier">
.nolist                 ;Turn off listing of headers - it distracts from code
;Revision History ---8051.h---------------------------------------------------
;1  Jan  1995  Original code
;8  May  2003  Cleaned up a little, took out references to older 80154
;21 Feb  2004  Put in old style equates: Lines marked "ser_par.txt fix"
;-----------------------------------------------------------------------------
;This module defines the basic registers and hardware ports on the 8051 & 8052
;An 8052 only adds Timer2+Memory to the standard 8051:  6 registers and 8 bits
;These days most chips are 8052+. The reg/bit names used are industry standard
;-----------------------------------------------------------------------------
;                        These next two lines are TASM assembler "fixes"
.msfirst                ;8051 saves MSB first in LCALL,ACALL - copy for ".dw"
#define .bit    .equ    ;TASM does not recognise ".bit" directive; make = .equ
;                        These next six lines are ser_par.txt "fixes"
#define ORG     .ORG    ;Old style equates: ser_par.txt fix
#define END     .end    ;Old style equates: ser_par.txt fix
#define equ     .equ    ;Old style equates: ser_par.txt fix
#define data    .equ    ;Old style equates: ser_par.txt fix
#define bit     .equ    ;Old style equates: ser_par.txt fix
#define 8051hdr         ;Old style equates: ser_par.txt fix
;-----------------------------------------------------------------------------
P0      .equ    080h    ;Port 0 - Not present on the 89C2051
SP      .equ    081h    ;Stack pointer
DPL     .equ    082h    ;Data pointer low, part of 16 bit reg with DPH
DPH     .equ    083h
PCON    .equ    087h    ;Power control, not bit addressable,
TCON    .equ    088h    ;Timer/counter control register, see bit list below
TMOD    .equ    089h    ;Timer/counter mode control register
TL0     .equ    08Ah    ;Timer 0 low
TL1     .equ    08Bh    ;Timer 1 low
TH0     .equ    08Ch    ;Timer 0 high - also reload val in 8bit auto RL mode
TH1     .equ    08Dh    ;Timer 1 high - also reload val in 8bit auto RL mode
P1      .equ    090h    ;Port 1
SCON    .equ    098h    ;Serial port control register, see bit list below
SBUF    .equ    099h    ;Serial buffer - read for Serial Rx, written to Tx
P2      .equ    0A0h    ;Port 2 - Not present on 89C2051
IE      .equ    0A8h    ;Interrupt enable register, see bit list below
P3      .equ    0B0h    ;Port 3
IP      .equ    0B8h    ;Interrupt priority register, see bit list below
T2CON   .equ    0C8h    ;Timer 2 Control reg (bit list below) (8052 only)
T2MOD   .equ    0C9h    ;Timer/Counter 2 mode control reg     (8052 only)
RCAP2L  .equ    0CAh    ;Timer 2 low byte capture             (8052 only)
RCAP2H  .equ    0CBh    ;Timer 2 high byte capture            (8052 only)
TL2     .equ    0CCh    ;Timer 2 low byte                     (8052 only)
TH2     .equ    0CDh    ;Timer 2 high byte                    (8052 only)
PSW     .equ    0D0h    ;Program status word, (bit list below)
ACC     .equ    0E0h    ;Accumulator
B       .equ    0F0h    ;Secondary Accumulator, used in Multiply and Divide
;-----------------------------------------------------------------------------
;PORT 0 BITS
P0.0    .bit    080h    ;Port 0 bit 0
P0.1    .bit    081h    ;Port 0 bit 1
P0.2    .bit    082h    ;Port 0 bit 2
P0.3    .bit    083h    ;Port 0 bit 3
P0.4    .bit    084h    ;Port 0 bit 4
P0.5    .bit    085h    ;Port 0 bit 5
P0.6    .bit    086h    ;Port 0 bit 6
P0.7    .bit    087h    ;Port 0 bit 7

;PORT 1 BITS
P1.0    .bit    090h    ;Port 1 bit 0
P1.1    .bit    091h    ;Port 1 bit 1
P1.2    .bit    092h    ;Port 1 bit 2
P1.3    .bit    093h    ;Port 1 bit 3
P1.4    .bit    094h    ;Port 1 bit 4
P1.5    .bit    095h    ;Port 1 bit 5
P1.6    .bit    096h    ;Port 1 bit 6
P1.7    .bit    097h    ;Port 1 bit 7

;PORT 2 BITS
P2.0    .bit    0A0h    ;Port 2 bit 0
P2.1    .bit    0A1h    ;Port 2 bit 1
P2.2    .bit    0A2h    ;Port 2 bit 2
P2.3    .bit    0A3h    ;Port 2 bit 3
P2.4    .bit    0A4h    ;Port 2 bit 4
P2.5    .bit    0A5h    ;Port 2 bit 5
P2.6    .bit    0A6h    ;Port 2 bit 6
P2.7    .bit    0A7h    ;Port 2 bit 7

;PORT 3 BITS
P3.0    .bit    0B0h    ;Port 3 bit 0
P3.1    .bit    0B1h    ;Port 3 bit 1
P3.2    .bit    0B2h    ;Port 3 bit 2
P3.3    .bit    0B3h    ;Port 3 bit 3
P3.4    .bit    0B4h    ;Port 3 bit 4
P3.5    .bit    0B5h    ;Port 3 bit 5
P3.6    .bit    0B6h    ;Port 3 bit 6
P3.7    .bit    0B7h    ;Port 3 bit 7

;PORT 3 ALTERNATE FUNCTIONS
RXD     .bit    P3.0
TXD     .bit    P3.1
INTO    .bit    P3.2
INT1    .bit    P3.3
;TO     .bit    P3.4    ;Has never been used
;T1     .bit    P3.5    ;Has never been used
WR      .bit    P3.6
RD      .bit    P3.7

;ACCUMULATOR BITS
ACC.0   .bit    0E0h    ;Acc bit 0
ACC.1   .bit    0E1h    ;Acc bit 1
ACC.2   .bit    0E2h    ;Acc bit 2
ACC.3   .bit    0E3h    ;Acc bit 3
ACC.4   .bit    0E4h    ;Acc bit 4
ACC.5   .bit    0E5h    ;Acc bit 5
ACC.6   .bit    0E6h    ;Acc bit 6
ACC.7   .bit    0E7h    ;Acc bit 7

;B REGISTER BITS
B.0     .bit    0F0h    ;Breg bit 0
B.1     .bit    0F1h    ;Breg bit 1
B.2     .bit    0F2h    ;Breg bit 2
B.3     .bit    0F3h    ;Breg bit 3
B.4     .bit    0F4h    ;Breg bit 4
B.5     .bit    0F5h    ;Breg bit 5
B.6     .bit    0F6h    ;Breg bit 6
B.7     .bit    0F7h    ;Breg bit 7

;PSW REGISTER BITS
P       .bit    0D0h    ;Parity flag
F1      .bit    0D1h    ;User flag 1
OV      .bit    0D2h    ;Overflow flag
RS0     .bit    0D3h    ;Register bank select 1
RS1     .bit    0D4h    ;Register bank select 0
F0      .bit    0D5h    ;User flag 0
AC      .bit    0D6h    ;Auxiliary carry flag (Rarely used)
CY      .bit    0D7h    ;Carry flag

;TCON REGISTER BITS
IT0     .bit    088h    ;Intr 0 type control
IE0     .bit    089h    ;Intr 0 edge flag
IT1     .bit    08Ah    ;Intr 1 type control
IE1     .bit    08Bh    ;Intr 1 edge flag
TR0     .bit    08Ch    ;Timer 0 run
TF0     .bit    08Dh    ;Timer 0 overflow
TR1     .bit    08Eh    ;Timer 1 run
TF1     .bit    08Fh    ;Timer 1 overflow

;SCON REGISTER BITS
RI      .bit    098h    ;RX Intr flag
TI      .bit    099h    ;TX Intr flag
RB8     .bit    09Ah    ;RX 9th bit
TB8     .bit    09Bh    ;TX 9th bit
REN     .bit    09Ch    ;Enable RX flag
SM2     .bit    09Dh    ;8/9 bit select flag
SM1     .bit    09Eh    ;Serial mode bit 1
SM0     .bit    09Fh    ;Serial mode bit 0

;IE REGISTER BITS
EX0     .bit    0A8h    ;External intr 0
ET0     .bit    0A9h    ;Timer 0 intr
EX1     .bit    0AAh    ;External intr 1
ET1     .bit    0ABh    ;Timer 1 intr
ES      .bit    0ACh    ;Serial port intr
ET2     .bit    0ADh    ;Timer 2 intr
;Reserved       0AEh    Reserved
EA      .bit    0AFh    ;Global intr enable

;IP REGISTER BITS
PX0     .bit    0B8h    ;Priority level-External intr 0
PT0     .bit    0B9h    ;Priority level-Timer 0 intr
PX1     .bit    0BAh    ;Priority level-External intr 1
PT1     .bit    0BBh    ;Priority level-Timer 1 intr
PS      .bit    0BCh    ;Priority level-Serial port intr
PT2     .bit    0BDh    ;Priority level-Timer 2 intr
;Reserved       0BEh    Reserved
;Reserved       0BFh    Reserved

;T2CON REGISTER BITS (8052 ONLY)
CAP2    .bit    0C8h    ;Timer 2 capture/reload flag
CNT2    .bit    0C9h    ;Timer 2 timer/counter select
TR2     .bit    0CAh    ;Timer 2 start/stop
EXEN2   .bit    0CBh    ;Timer 2 external enable
TCLK    .bit    0CCh    ;TX clock flag
RCLK    .bit    0CDh    ;RX clock flag
EXF2    .bit    0CEh    ;Timer 2 external flag
TF2     .bit    0CFh    ;Timer 2 overflow
;-----------------------------------------------------------------------------
;<!HTML></pre></font><a href="index.htm">Up to parent Document</a></body></html>
.list

